func gauss(ref a, eps)
    m = len(a);     // Number of rows of matrix
    n = len(a[0]);  // Number of columns
    
    func showMatrix()
        println("Matrix:");
        i = 0;
        while (i < m)
            println(a[i]);
            i = i + 1;
        endwhile
    endfunc

    func swapLines(i, j)
        k = 0;
        while (k < n)
            tmp = a[i][k];
            a[i][k] = a[j][k];
            a[j][k] = -tmp;
            k = k + 1;
        endwhile
    endfunc
    
    func addLine(i, j, c)
        k = 0;
        while (k < n)
            a[i][k] = a[i][k] + a[j][k]*c;
            k = k + 1;
        endwhile
    endfunc
    
    i = 0; j = 0;
    while (i < m && j < n)
        // Find the maximal element in j-th column starting
        // from i-th row
        maxelem = fabs(a[i][j]);
        maxidx = i;
        k = i + 1;
        while (k < m)
            if (fabs(a[k][j]) > maxelem)
                maxelem = fabs(a[k][j]);
                maxidx = k;
            endif
            k = k + 1;
        endwhile
        
        if (maxelem <= eps)
            j = j + 1;
            continue;
        endif
        
        if (i != maxidx) 
            swapLines(i, maxidx);
        endif
        
        k = i + 1;
        while (k < m)
            c = (-a[k][j]/a[i][j]);
            addLine(k, i, c);
            a[k][j] = 0.;
            k = k + 1;
        endwhile
        // showMatrix();
        i = i + 1; j = j + 1;
    endwhile
    return i;
endfunc

a = [[1., 2., 3.], [4., 5., 6.], [7., 8., 9.]];
println(a[0]);    
println(a[1]);    
println(a[2]);
println();

r = gauss(a, 1e-12);
println("Echelonized a:");
println(a[0]);    
println(a[1]);    
println(a[2]);
println();

println("rank = ", r);
det = a[0][0]*a[1][1]*a[2][2];
println("det = ", det);

